;;LSP
;;Modelação e Visualização Tridimencional em Arquitetura
;;Inês Barbosa

(defun c:escadas3d ()

  ;; prepair the control of osnap
  (setq pontoS2d (getvar "osmode"))
  (setq pontoS3d (getvar "3dosmode"))
  (setq eco (getvar "CMDECHO"))
  (setvar "3dosmode" 0)
  (setvar "osmode" 1)
  (setvar "CMDECHO" 0)
  
  
  ;; set the UCS to the X-axis
  (command "_.ucs" w "")
  (command "_.ucs" "_x" 90)

;;informação
  (setq p1 (getpoint "\nQual é o ponto de partida?" )) ; O ponto de partida dado pelo utilizador
  (setq riser (getpoint "\nInserir altura do espelho:" )) ; A altura do espelho dado pelo utilizador
  (setq tread (getpoint "\nInserir medida do cobertor:"))
  ;(setq tread (- 0.64 (* riser 2))) ; A medida do cobertor é calculada pelo calculo de conforto
  (setq width (getreal "\nInserir a largura dos degraus:" )) ; Largura dos degraus dado pelo utilizador
  (setq n_steps (getreal "\nQuantos degraus?" )) ; Número total de degraus
  (setq height_landing 0.2) ; Altura do patamar em metros
  ;(setq offset_x (getreal "\nQual o espaçamento no eixo do X?" ))
  ;(setq offset_y (getreal "\nQual o espaçamento no eixo do Y?" ))

 
  ;; calculate additional points and dimensions
  (setq p2 (list (car p1) (+ (cadr p1) riser)))
  (setq p3 (list (+ (car p1) tread) (cadr p2)))
  
  ;; draw the first step
  (command "_.rectang" p3 p1)
  (command "_.extrude" "_last" "" w)


  (command "_.3dface") ; Começa a criação de um 3Dface

  ; Cria os vértices do 3Dface para cada degrau até o patamar
  (setq i 0)
  (while (< i (/ n_steps 2))
    (setq x (* riser i))
    (setq y (* tread i))
    (command x y 0)
    (setq x (* riser (+ i 1)))
    (command x y 0)
    (setq y (* tread (+ i 1)))
    (command x y 0)
    (setq x (* riser i))
    (command x y 0)
    (setq i (+ i 1))
  )

  ; Cria os vértices do 3Dface para o patamar
  (setq x (* riser (/ n_steps 2)))
  (setq y (* tread (/ n_steps 2)))
  (command x y 0)
  (setq y (+ y height_landing))
  (command x y 0)
  (setq x (* riser (+ (/ n_steps 2) 1)))
  (command x y 0)
  (command "")

  ; Cria os vértices do 3Dface para os degraus restantes
  (setq i (/ n_steps 2))
  (while (< i n_steps)
    (setq x (* riser i))
    (setq y (+ (* tread (/ n_steps 2)) (* height_landing (- i (/ n_steps 2) 1))))
    (command x y 0)
    (setq x (* riser (+ i 1)))
    (command x y 0)
    (setq y (+ (* tread (/ n_steps 2)) (* height_landing (- (+ i 1) (/ n_steps 2) 1))))
    (command x y 0)
    (setq x (* riser i))
    (command x y 0)
    (setq i (+ i 1))
  )


  (command "") ; Termina a criação do 3Dface

  (princ)
)
